using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace Tests
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtQuestion;
		private System.Windows.Forms.GroupBox gbVariants;
		private System.Windows.Forms.Button btnFirst;
		private System.Windows.Forms.Button btnPrev;
		private System.Windows.Forms.Button btnLast;
		private System.Windows.Forms.Button btnCheck;
		private System.Windows.Forms.Button btnNext;
		private System.Data.DataSet dsTests;
		private System.Data.DataTable dtQuestions;
		private System.Data.DataColumn dcQuestion;
		private System.Data.DataColumn dcQuestType;
		private System.Data.DataTable dtVariants;
		private System.Data.DataColumn dcID;
		private System.Data.DataColumn dcVariantQuestID;
		private System.Data.DataColumn dcVariant;
		private System.Data.DataColumn dcIsRight;

		CurrencyManager cmTest = null;
		private System.Data.DataColumn dcQuestID;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public enum QuestionType
		{
			SingleVariant,
			MultiVariant
		}
		public enum Direction
		{
			First,
			Prev,
			Next,
			Last
		}
		private void LoadDataBase()
		{
			SqlConnection conn = new SqlConnection("Data Source=.;Initial Catalog=Tests;Integrated Security=SSPI;");

			SqlDataAdapter questAdapter = new SqlDataAdapter("select * from questions", conn);
			SqlDataAdapter variantsAdapter = new SqlDataAdapter("select * from variants", 	conn);

			conn.Open();
			//  "Questions"   questAdapter
			questAdapter.Fill(dsTests.Tables["Questions"]);
			//  "Variants"   variantsAdapter
			variantsAdapter.Fill(dsTests.Tables["Variants"]);
			conn.Close();
		}
		//  clientAnswers    
		Hashtable clientAnswers = new Hashtable();

		//  keys      
		Hashtable keys = new Hashtable();
		
		private void InitAnswersKeysTable()
		{  
			//  ,        "Questions"
			for(int i = 0; i < dsTests.Tables["Questions"].Rows.Count; i++)
			{
	
				//     Questions.
				DataRow drquestion = dsTests.Tables["Questions"].Rows[i];
			
				//     Variants.
				DataRow[] drvariants = drquestion.GetChildRows(dsTests.Relations["QuestionsVariants"]);
			
				//   j  false   .
				bool[] answers = new bool[drvariants.Length];
				for(int j = 0; j < answers.Length; j++)
					answers[j] = false;
			
				//     Hashtable
				keys.Add(drquestion, drvariants);
				clientAnswers.Add(drquestion, answers);
			}
		}
		private void InitDefaultSettings()
		{
			//  Tag       Direction
			btnFirst.Tag = Direction.First;
			btnPrev.Tag = Direction.Prev;
			btnNext.Tag = Direction.Next;
			btnLast.Tag = Direction.Last;
			
			//      btnFirst_Click
			btnFirst.Click += new EventHandler(btnFirst_Click);
			btnPrev.Click += new EventHandler(btnFirst_Click);
			btnNext.Click += new EventHandler(btnFirst_Click);
			btnLast.Click += new EventHandler(btnFirst_Click);

			//  
			LoadDataBase();
			
			//   ,        "Questions"
			if(dsTests.Tables["Questions"].Rows.Count == 0)
			{
				txtQuestion.Text = "   ";
				btnFirst.Enabled= false;
				btnPrev.Enabled	= false;
				btnNext.Enabled= false;
				btnLast.Enabled= false;
				btnCheck.Enabled= false;
			}
			else
			{
				// . 
				InitAnswersKeysTable();
				//  cmTest    "Questions"
				cmTest = (CurrencyManager)this.BindingContext[dsTests, "Questions"];
				//   
				cmTest.PositionChanged += new EventHandler(cmTest_PositionChanged);
			
				ShowQuestion(dsTests.Tables["questions"].Rows[0]);
				//   ">"  ">>"
				btnFirst.Enabled= false;
				btnPrev.Enabled= false;
				btnNext.Enabled= true;
				btnLast.Enabled= true;
			}
		}

		private void cmTest_PositionChanged(object sender, EventArgs e)
		{
			if (cmTest.Position == 0)
			{
				btnPrev.Enabled = false;
				btnFirst.Enabled = false;
				btnNext.Enabled = true;
				btnLast.Enabled = true;
			}
			else if(cmTest.Position == dsTests.Tables["questions"].Rows.Count - 1)
			{
				btnNext.Enabled = false;
				btnLast.Enabled = false;
				btnPrev.Enabled = true;
				btnFirst.Enabled = true;
			}
			else
			{
				btnPrev.Enabled = true;
				btnFirst.Enabled = true;
				btnNext.Enabled = true;
				btnLast.Enabled = true;
			}
		}

		private void btnFirst_Click(object sender, EventArgs e)
		{
			Button btn = (Button)sender;
			Direction direction = (Direction)btn.Tag;

			switch (direction)
			{
				case Direction.First:
					cmTest.Position = 0;
					break;
				case Direction.Prev:
					--cmTest.Position;
					break;
				case Direction.Next:
					++cmTest.Position;
					break;
				case Direction.Last:
					cmTest.Position = dsTests.Tables["questions"].Rows.Count - 1;
					break;
			}

			int rowIndex = cmTest.Position;
			//  ShowQuestion,     
			ShowQuestion(dsTests.Tables["questions"].Rows[rowIndex]);
		}

		public Form1()
		{
			InitializeComponent();
			InitDefaultSettings();
		}

		private void ShowQuestion(DataRow drquestion)
		{
			txtQuestion.Text = drquestion["question"].ToString();
			//  ShowVariants,      
			ShowVariants(drquestion);			
		}
		private void ShowVariants(DataRow question)
		{
			//    GroupBox
			gbVariants.Controls.Clear();
			//   childVariants      "Variants"
			DataRow[] childVariants = question.GetChildRows(dsTests.Relations["QuestionsVariants"]);
			
			//  
			bool[] vars = (bool[])clientAnswers[question];
			int i = 0;			
			QuestionType questType = (QuestionType)question["questType"];
			switch(questType)
			{
				//      , 
				//     Radiobutton
					case QuestionType.SingleVariant:
					foreach(DataRow childVariant in childVariants)
					{
						RadioButton rb = new RadioButton();

						#region      
						bool selectedAnswer = (bool)vars[i++];

						rb.Checked = selectedAnswer;
						#endregion
						//    RadioButton
						rb.Text = childVariant["variant"].ToString();
						rb.Tag = childVariant;
						rb.CheckedChanged += new EventHandler(rb_CheckedChanged);
						
						int y = (gbVariants.Controls.Count == 0)?20:
														
							((RadioButton)gbVariants.Controls[gbVariants.Controls.Count - 1]).Bottom + 2;
						//    RadioButton
						//500 -   , rb.Height+5 - 
						rb.Size = new Size(500, rb.Height+5);
						rb.Location = new Point(10, y);
						gbVariants.Controls.Add(rb);
					}
					break;
					//      , 
					//     CheckBox
					case QuestionType.MultiVariant:
					foreach(DataRow childVariant in childVariants)
					{
						CheckBox chb = new CheckBox();

						#region      
						bool selectedAnswer = (bool)vars[i++];

						chb.Checked = selectedAnswer;
						#endregion
						
						//    RadioButton
						chb.Text = childVariant["variant"].ToString();
						chb.Tag = childVariant;
						chb.CheckedChanged += new EventHandler(chb_CheckedChanged);
						
						int y = (gbVariants.Controls.Count == 0)?20:
							
							((CheckBox)gbVariants.Controls[gbVariants.Controls.Count - 1]).Bottom + 2;
						//    RadioButton
						//500 -   , chb.Height+5 - 
						chb.Size = new Size( 500, chb.Height+5);
						chb.Location = new Point(10, y);
						gbVariants.Controls.Add(chb);
					}
					break;
			}
		}
		private void rb_CheckedChanged(object sender, EventArgs e)
		{
			RadioButton rb = (RadioButton)sender;
			if(!rb.Checked)
				return;
			//  drvariant  DataRow    
			// Tag  RadioButton
			DataRow drvariant = (DataRow)rb.Tag;
			//    cmTest
			int questIndex = cmTest.Position;
			DataRow drquestion = dsTests.Tables["Questions"].Rows[questIndex];

			int answIndex = gbVariants.Controls.IndexOf(rb);
			//  RadioButton ,     
			bool[] answers = (bool[])clientAnswers[drquestion];
			for(int i = 0; i < answers.Length; i++)
			{
				if(i == answIndex)
					answers[i] = rb.Checked;
				else
					answers[i] = !rb.Checked;
			}
		}


		private void chb_CheckedChanged(object sender, EventArgs e)
		{
			CheckBox chb = (CheckBox)sender;
			//  drvariant  DataRow    
			// Tag  CheckBox
			DataRow drvariant = (DataRow)chb.Tag;
			//    cmTest
			int rowIndex = cmTest.Position;
			DataRow drquestion = dsTests.Tables["Questions"].Rows[rowIndex];

			int answIndex = gbVariants.Controls.IndexOf(chb);
			//  CheckBox ,     
			bool[] answers = (bool[])clientAnswers[drquestion];

			for(int i = 0; i< answers.Length; i++)
			{
				if (i == answIndex)
				{
					answers[i] = chb.Checked;
				
					break;
				}
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtQuestion = new System.Windows.Forms.TextBox();
			this.gbVariants = new System.Windows.Forms.GroupBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnFirst = new System.Windows.Forms.Button();
			this.btnPrev = new System.Windows.Forms.Button();
			this.btnLast = new System.Windows.Forms.Button();
			this.btnCheck = new System.Windows.Forms.Button();
			this.btnNext = new System.Windows.Forms.Button();
			this.dsTests = new System.Data.DataSet();
			this.dtQuestions = new System.Data.DataTable();
			this.dcQuestID = new System.Data.DataColumn();
			this.dcQuestion = new System.Data.DataColumn();
			this.dcQuestType = new System.Data.DataColumn();
			this.dtVariants = new System.Data.DataTable();
			this.dcID = new System.Data.DataColumn();
			this.dcVariantQuestID = new System.Data.DataColumn();
			this.dcVariant = new System.Data.DataColumn();
			this.dcIsRight = new System.Data.DataColumn();
			((System.ComponentModel.ISupportInitialize)(this.dsTests)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dtQuestions)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dtVariants)).BeginInit();
			this.SuspendLayout();
			// 
			// txtQuestion
			// 
			this.txtQuestion.Location = new System.Drawing.Point(12, 24);
			this.txtQuestion.Multiline = true;
			this.txtQuestion.Name = "txtQuestion";
			this.txtQuestion.Size = new System.Drawing.Size(520, 90);
			this.txtQuestion.TabIndex = 8;
			this.txtQuestion.Text = "";
			// 
			// gbVariants
			// 
			this.gbVariants.Location = new System.Drawing.Point(12, 120);
			this.gbVariants.Name = "gbVariants";
			this.gbVariants.Size = new System.Drawing.Size(520, 150);
			this.gbVariants.TabIndex = 1;
			this.gbVariants.TabStop = false;
			this.gbVariants.Text = " ";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.TabIndex = 2;
			this.label1.Text = ":";
			// 
			// btnFirst
			// 
			this.btnFirst.Location = new System.Drawing.Point(24, 280);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.TabIndex = 3;
			this.btnFirst.Text = "<<";
			// 
			// btnPrev
			// 
			this.btnPrev.Location = new System.Drawing.Point(99, 280);
			this.btnPrev.Name = "btnPrev";
			this.btnPrev.TabIndex = 4;
			this.btnPrev.Text = "<";
			// 
			// btnLast
			// 
			this.btnLast.Location = new System.Drawing.Point(249, 280);
			this.btnLast.Name = "btnLast";
			this.btnLast.TabIndex = 6;
			this.btnLast.Text = ">>";
			// 
			// btnCheck
			// 
			this.btnCheck.Location = new System.Drawing.Point(360, 280);
			this.btnCheck.Name = "btnCheck";
			this.btnCheck.Size = new System.Drawing.Size(150, 23);
			this.btnCheck.TabIndex = 7;
			this.btnCheck.Text = "";
			this.btnCheck.Click += new System.EventHandler(this.btnCheck_Click);
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(174, 280);
			this.btnNext.Name = "btnNext";
			this.btnNext.TabIndex = 0;
			this.btnNext.Text = ">";
			// 
			// dsTests
			// 
			this.dsTests.DataSetName = "NewDataSet";
			this.dsTests.Locale = new System.Globalization.CultureInfo("ru-RU");
			this.dsTests.Relations.AddRange(new System.Data.DataRelation[] {
																			   new System.Data.DataRelation("QuestionsVariants", "Questions", "Variants", new string[] {
																																										   "questID"}, new string[] {
																																																		"questID"}, false)});
			this.dsTests.Tables.AddRange(new System.Data.DataTable[] {
																		 this.dtQuestions,
																		 this.dtVariants});
			// 
			// dtQuestions
			// 
			this.dtQuestions.Columns.AddRange(new System.Data.DataColumn[] {
																			   this.dcQuestID,
																			   this.dcQuestion,
																			   this.dcQuestType});
			this.dtQuestions.Constraints.AddRange(new System.Data.Constraint[] {
																				   new System.Data.UniqueConstraint("Constraint1", new string[] {
																																					"questID"}, false)});
			this.dtQuestions.TableName = "Questions";
			// 
			// dcQuestID
			// 
			this.dcQuestID.ColumnName = "questID";
			this.dcQuestID.DataType = typeof(int);
			// 
			// dcQuestion
			// 
			this.dcQuestion.ColumnName = "question";
			// 
			// dcQuestType
			// 
			this.dcQuestType.ColumnName = "questType";
			this.dcQuestType.DataType = typeof(int);
			// 
			// dtVariants
			// 
			this.dtVariants.Columns.AddRange(new System.Data.DataColumn[] {
																			  this.dcID,
																			  this.dcVariantQuestID,
																			  this.dcVariant,
																			  this.dcIsRight});
			this.dtVariants.Constraints.AddRange(new System.Data.Constraint[] {
																				  new System.Data.UniqueConstraint("Constraint1", new string[] {
																																				   "id"}, false),
																				  new System.Data.ForeignKeyConstraint("QuestionsVariants", "Questions", new string[] {
																																										  "questID"}, new string[] {
																																																	   "questID"}, System.Data.AcceptRejectRule.None, System.Data.Rule.Cascade, System.Data.Rule.Cascade)});
			this.dtVariants.TableName = "Variants";
			// 
			// dcID
			// 
			this.dcID.ColumnName = "id";
			this.dcID.DataType = typeof(int);
			// 
			// dcVariantQuestID
			// 
			this.dcVariantQuestID.ColumnName = "questID";
			this.dcVariantQuestID.DataType = typeof(int);
			// 
			// dcVariant
			// 
			this.dcVariant.ColumnName = "variant";
			// 
			// dcIsRight
			// 
			this.dcIsRight.ColumnName = "isRight";
			this.dcIsRight.DataType = typeof(bool);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 318);
			this.Controls.Add(this.txtQuestion);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnCheck);
			this.Controls.Add(this.btnLast);
			this.Controls.Add(this.btnPrev);
			this.Controls.Add(this.btnFirst);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.gbVariants);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "";
			((System.ComponentModel.ISupportInitialize)(this.dsTests)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dtQuestions)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dtVariants)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());

		}

		private void btnCheck_Click(object sender, System.EventArgs e)
		{
			// 
			double counter = 0;
			//    key  Hashtable, 
			//    
			foreach(object key in keys.Keys)
			{
				bool flag = true;
				DataRow[] drvariants = (DataRow[])keys[key];
				bool[] answers = (bool[])clientAnswers[key];
				int i = 0;
				foreach(DataRow variant in drvariants)
				{
					if(((bool)variant["isRight"]) == answers[i++])
						continue;
					else
					{
						flag = false;
						break;
					}
				}

				if (flag)
					++counter;
			}
			//      c ,    100
			int result = (int)(counter / dsTests.Tables["questions"].Rows.Count * 100);

			MessageBox.Show(String.Format("    {0}% .", result), " ",  MessageBoxButtons.OK, MessageBoxIcon.Information);

			}
		
		}
	}

